/* Sweep
 by BARRAGAN <http://barraganstudio.com>
 This example code is in the public domain.

 modified 8 Nov 2013
 by Scott Fitzgerald
 http://www.arduino.cc/en/Tutorial/Sweep
*/


//SERVO notes: Black, red, white, black is closest to the USB input. 0 rotates full speed clockwise (open door), 180 rotates c.clockwise (close/push door); 85 full stop
// on Adafruit shield, Servo 2 is pin 9, Servo 1 is pin 10 on Arduino

#include <Wire.h>
#include <Adafruit_MotorShield.h>
#include "Adafruit_PWMServoDriver.h"


//Stepper

Adafruit_MotorShield AFMS = Adafruit_MotorShield(); 
// Request stepper from motorshield with getStepper(steps, stepper#).

//Steps indicates how many steps per revolution the motor has. A 7.5 degree/step motor has 360/7.5 = 48 steps.

// Stepper# is which port it is connected to. If you're using M1 and M2, its port 1. If you're using M3 and M4 indicate port 2

Adafruit_StepperMotor *myMotor = AFMS.getStepper(200, 2); //200 steps per revolution, port 2



//switches for doors, eleator car

//momentary switches, looking from the inside A, is actually on the bottom right, by the counterweight
/* ___________________
 * |         A        |
 * |         __       |
 * |   F    |  |  B   |  
 * |        }  |      |
 * |                  |
 * |                  |
 * |         __       |
 * |        |  |      |
 * |   E    |  |  C   |
 *            D
*/

int switchB = 2; //2F open
int switchF = 3; //2F closed

int switchE = 4; //1F closed
int switchC = 6; //1F open

int switchA = 5; //Car at top
int switchD = 7; //car at bottom
 
int upArrow = 11;
int downArrow = 12;

int upLED = A3;
int downLED = A2;


//int carLED = 11;


#include <Servo.h>

Servo myservo1;  // create servo object to control a servo
Servo myservo2;
// twelve servo objects can be created on most boards




void setup() {

  Serial.begin(9600);           // set up Serial library at 9600 bps


  AFMS.begin();  // create with the default frequency 1.6KHz
  //AFMS.begin(1000);  // OR with a different frequency, say 1KHz

myMotor->setSpeed(50); // rpm


myservo2.write(85); //send stop commmand so they don't move. They still twitch
myservo1.write(85);
myservo2.attach(9);  // attaches the servo on pin 9 to the servo object
myservo1.attach(10);


pinMode(switchB, INPUT); //wire from NO pin on the momentary switch
digitalWrite(switchB, HIGH); //enables pullup resistors. When pin goes LOW (grounded) that means the switch was tripped, ie SECOND FLOOR door is OPEN

pinMode(switchF, INPUT); //wire from NO pin on the momentary switch
digitalWrite(switchF, HIGH); //enables pullup resistors. When pin goes LOW (grounded) that means the switch was tripped, ie SECOND FLOOR door is CLOSED

pinMode(switchC, INPUT); //wire from NO pin on the momentary switch
digitalWrite(switchC, HIGH); //enables pullup resistors. When pin goes LOW (grounded) that means the switch was tripped, ie FIRST FLOOR door is OPEN

pinMode(switchE, INPUT); //wire from NO pin on the momentary switch
digitalWrite(switchE, HIGH); //enables pullup resistors. When pin goes LOW (grounded) that means the switch was tripped, ie FIRST FLOOR door is CLOSED

pinMode(switchA, INPUT); //wire from NO pin on the momentary switch
digitalWrite(switchA, HIGH); //car has reached the TOP

pinMode(switchD, INPUT); //wire from NO pin on the momentary switch
digitalWrite(switchD, HIGH); // car has hit the BOTTOM



//flash to say hello

analogWrite(upLED,255);
analogWrite(downLED,0);
delay(500);
analogWrite(upLED,0);
analogWrite(downLED,255);
delay(500);
analogWrite(upLED,255);
analogWrite(downLED,0);
delay(500);
analogWrite(upLED,0);
analogWrite(downLED,255);
delay(500);


//up and down buttons
pinMode(upArrow,INPUT);
digitalWrite(upArrow, HIGH);
pinMode(downArrow,INPUT);
digitalWrite(downArrow,HIGH);

//LEDs in buttons
pinMode(upLED,OUTPUT);
analogWrite(upLED,0);
pinMode(downLED,OUTPUT);
analogWrite(downLED,0);

//code for fading the LEDs 
int brightness = 0;    // how bright the LED is
int fadeAmount = 5;    // how many points to fade the LED by

//reset doors
/*

while (digitalRead(switchC) == HIGH) {
  myservo1.write(40);
}

while (digitalRead(switchE) == HIGH) {
  myservo1.write(120);
}
myservo1.write(85);



while (digitalRead(switchB) == HIGH) {
  myservo2.write(40);
}
while (digitalRead(switchF) == HIGH) {
  myservo2.write(120);
}
myservo2.write(85);

 Serial.println(digitalRead(switchE));

*/


//Serial.println(digitalRead(switchE));

myservo2.write(85); //
myservo1.write(85);

//keep arrow LEDs off until pressed
analogWrite(upLED,0);
analogWrite(downLED,0);

}


void loop() {



//main loop looks for up or down button presses

//Serial.println(digitalRead(switchE));


if (digitalRead(upArrow) == LOW && digitalRead(downArrow) == LOW) {
 delay(50);
  Reset();
  
}



if (digitalRead(upArrow) == LOW)  {
 delay(500);
  Up();
}

if (digitalRead(downArrow) == LOW) {
  delay(500);
  Down();
}






// pulseTheTOPButton ();

// pulseTheBOTTOMButton ();



//Serial.println(digitalRead(upArrow));
 // Serial.println(myservo1.read()); // tells what value servo was given
  
 //Serial.println(digitalRead(switchB)); 
 //Serial.println(digitalRead(switchF));




// 180 is full speed. 86 is stop. Above 86 is close (counterclockwise), so 87 is really slow. 84 should go the other way slow



myservo1.write(85);
myservo2.write(85);


// FORWARD lowers the car, BACKWARD lowers the car
//stepper test
// Serial.println("Single coil steps");
// myMotor->step(100, FORWARD, SINGLE); 
 // myMotor->step(100, BACKWARD, SINGLE); 


//moved to program

/*
Serial.println("Double coil steps");

//send car down

while (digitalRead(switchD) == HIGH) {
  myMotor->step(2, FORWARD, DOUBLE);
}
// myMotor->setSpeed(0);


Serial.println("car on first floor");

//open door after hitting the floor

while (digitalRead(switchC) == HIGH) {
  myservo1.write(40);
}
delay(1000);
while (digitalRead(switchE) == HIGH) {
  myservo1.write(120);
}
myservo1.write(85);

Serial.println("door closed");
*/

// myMotor->step(100, FORWARD, DOUBLE); 
// myMotor->step(100, BACKWARD, DOUBLE);
  
/*
Serial.println("Interleave coil steps");
  myMotor->step(100, FORWARD, INTERLEAVE); 
  myMotor->step(100, BACKWARD, INTERLEAVE); 
  
  Serial.println("Microstep steps");
  myMotor->step(50, FORWARD, MICROSTEP); 
  myMotor->step(50, BACKWARD, MICROSTEP);
*/
 
  



  }
 
// myservo2.write(86);   //stop
//  myservo2.write(0); // open door/retract pusher
//  myservo2.write(180); // close door/extend pusher
 



void Up()  {

analogWrite(upLED, 255);
delay(500);
if (digitalRead(switchD) == LOW) {  //if car is at bottom (D)  Switches are LOW when pressed.

  DoorOnly1F();
}
 if (digitalRead(switchD) == HIGH) {
  DoorAndCar1F();
 }
  
}



void DoorOnly1F()    {    //opens and closes the door, does not move car
 analogWrite(upLED, 255);
delay(500);
while (digitalRead(switchC) == HIGH) {
 myservo1.write(42); //open half speed
}
myservo1.write(85);

delay(5000);

//light blinks thrice to warn of door closing
analogWrite(upLED,0);
delay(500);

analogWrite(upLED,255);
delay(500);

analogWrite(upLED,0);
delay(500);

analogWrite(upLED,255);
delay(500);

analogWrite(upLED,0);
delay(500);

analogWrite(upLED,255);
delay(500);


while (digitalRead(switchE) == HIGH) {
  myservo1.write(100);
}
myservo1.write(85);

analogWrite(upLED,0);
analogWrite(downLED,0);
 loop();
}


void DoorAndCar1F()   {
//analogWrite(upLED, 255);
delay(500);



Serial.println("DoorAndCar1F");

//send car down

while (digitalRead(switchD) == HIGH) {
  myMotor->step(2, FORWARD, DOUBLE);
}
// myMotor->setSpeed(0);


Serial.println("car on first floor");

//open door after hitting the floor

while (digitalRead(switchC) == HIGH) {
  myservo1.write(40);
}
myservo1.write(85);
delay(5000);

//light blinks thrice to warn of door closing
analogWrite(upLED,0);
delay(500);

analogWrite(upLED,255);
delay(500);

analogWrite(upLED,0);
delay(500);

analogWrite(upLED,255);
delay(500);

analogWrite(upLED,0);
delay(500);

analogWrite(upLED,255);
delay(500);


while (digitalRead(switchE) == HIGH) {
  myservo1.write(120);
}
myservo1.write(85);

Serial.println("door closed");

analogWrite(upLED,0);
analogWrite(downLED,0);

loop();

  
}




void Down() {
  analogWrite(downLED, 255);
  delay(500); //for testing


if (digitalRead(switchA) == LOW) {  //if car is at top i.e. counterweight is on (A)  Switches are LOW when pressed.

  DoorOnly2F();
}
 if (digitalRead(switchA) == HIGH) {  //i.e. car is at 2F
  DoorAndCar2F();
 }
}

//programs for 2F button

void DoorOnly2F()    {    //opens and closes the door, does not move car
 analogWrite(downLED, 255);
delay(500);

while (digitalRead(switchB) == HIGH) {
  myservo2.write(40);
}
myservo2.write(85);
delay(5000);

//light blinks thrice to warn of door closing
analogWrite(downLED,0);
delay(500);

analogWrite(downLED,255);
delay(500);

analogWrite(downLED,0);
delay(500);

analogWrite(downLED,255);
delay(500);

analogWrite(downLED,0);
delay(500);

analogWrite(downLED,255);
delay(500);


while (digitalRead(switchF) == HIGH) {
  myservo2.write(120);
}
myservo1.write(85);


  analogWrite(upLED,0);
analogWrite(downLED,0);

 loop();
}


void DoorAndCar2F()   {
//analogWrite(downLED, 255);
delay(500);



Serial.println("DoorAndCar2F");

//send car up

while (digitalRead(switchA) == HIGH) {
  myMotor->step(2, BACKWARD, DOUBLE);
}
// myMotor->setSpeed(0);


Serial.println("car on second floor");

//open door after hitting the floor

while (digitalRead(switchB) == HIGH) {
  myservo2.write(40);
}
myservo2.write(85);
delay(5000);

//light blinks thrice to warn of door closing
analogWrite(downLED,0);
delay(500);

analogWrite(downLED,255);
delay(500);

analogWrite(downLED,0);
delay(500);

analogWrite(downLED,255);
delay(500);

analogWrite(downLED,0);
delay(500);

analogWrite(downLED,255);
delay(500);

while (digitalRead(switchF) == HIGH) {
  myservo2.write(120);
}
myservo1.write(85);

Serial.println("door closed");
analogWrite(upLED,0);
analogWrite(downLED,0);

loop();

  
}






void Reset() {
while (digitalRead(switchC) == HIGH) {
  myservo1.write(40);
}


while (digitalRead(switchB) == HIGH) {
  myservo2.write(40);
}


delay(1000);

while (digitalRead(switchE) == HIGH) {
  myservo1.write(120);
}
while (digitalRead(switchF) == HIGH) {
  myservo2.write(120);
}

}
